Bug 88093 - setcontext() is not signal safe
Summary: setcontext() is not signal safe
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Linux
Classification: Retired
Component: glibc
Version: 9
Hardware: i386
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jakub Jelinek
QA Contact: Brian Brock
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2003-04-05 15:41 UTC by John Reiser
Modified: 2016-11-24 14:48 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2003-04-09 19:21:38 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2003:136 high SHIPPED_LIVE glibc bugfix errata 2003-04-09 04:00:00 UTC
Red Hat Product Errata RHSA-2003:089 high SHIPPED_LIVE : Updated glibc packages fix vulnerabilities in RPC XDR decoder 2003-04-10 04:00:00 UTC

Description John Reiser 2003-04-05 15:41:26 UTC
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.0.0) Gecko/20020529

Description of problem:
setcontext() temporarily stores the new register values on the stack at
addresses less than the stack pointer (before 'popa' to set the new values).  If
a signal is delivered between the store and the popa, then the locations that
are read by popa get overwritten, so eventually the wrong values will be set
into the registers.

Version-Release number of selected component (if applicable):
glibc-2.3.2-11.9

How reproducible:
Always

Steps to Reproduce:
1.Run testcase stdlib/tst-setcontext under gdb.
2.Set a breakpoint at setcontext+67: mov %ebx,(%ecx)
3.Print $ecx and $esp at the breakpoint.

    

Actual Results:
$esp = 0xffffcb1c
$ecx = 0xffffcafc   # 0x20 less than $esp


Expected Results:
$esp = 0xffffcafc
$ecx = 0xffffcafc  # == $esp

Additional info:

Fix: move the  "movl %ecx, %esp" at line 85 of
sysdeps/unix/sysv/linux/i386/setcontext.S to just after the "subl $36, %ecx" at
line 60.

Comment 1 John Reiser 2003-04-06 04:52:51 UTC
A similar problem exists in sysdeps/unix/sysv/linux/i386/swapcontext.S at lines
89 and 114.


Comment 2 Jakub Jelinek 2003-04-09 19:21:38 UTC
An errata has been issued which should help the problem described in this bug report. 
This report is therefore being closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files, please follow the link below. You may reopen 
this bug report if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2003-136.html



Note You need to log in before you can comment on or make changes to this bug.